def proc error_in_parser
rem this gets the error lines from the parser error report
rem and makes them into the app sub window array
rem
rem this uses the global vars errfile$ , subwinarray$
rem modulefile$,linenumber$,is_sbasic%
rem
rem it is supposed that the error report lines are all in the followinh format:
rem (for parser: xxxxx error string, where xxxxx =  line n)
rem (for sbasic: At line xxxxx error string)
rem
rem  v. 1.01
local lp%,chan%,lineno%,a$,counter%,a%
  chan%=fop_in(errfile$)
  if chan%<0:return		: rem no error file = no error
  length=flen(#chan%)
  length=int(length/20) 	: rem gross calculation....
  dim subwinarray$(length+5,80),modulefile$(length+5,46),linenumber$(length+5,5)
  counter%=1
  rep lp%
    if eof(#chan%):exit lp%
    input#chan%,a$		: rem this is the line with the error
    if a$="":next lp%
    if is_sbasic%
	if a$(1 to 7)=='at line'
	    a$=a$(9 to )	: rem strip off 'at line ' if sbasic error report
	else
	    next lp%		: rem possible 'unknown procedure' because of long filename'
	endif
    endif
    lineno%=get_lineno%(a$)	: rem get the line number
    if not get_file%(lineno%,counter%):exit lp%  : rem get error line & filename
    if is_sbasic%
       a%=" " instr a$
       if a%:a$=a$(a%+1 to)
    else
       input#chan%,a$		: rem error type - apppend it to ...
    endif
    subwinarray$(counter%)=subwinarray$(counter%)&a$ : rem ... the error line
    counter%=counter%+1
  end rep lp%
  close#chan%
  mk_main_app			: rem make appsubwindow
  ap_in main_defn,app_addr+180	: rem put the appsub definition in
  dr_wdrw main_defn		: rem and redraw the window
end def error_in_parser
:
def fn get_lineno%(line$)
rem this extracts the linenumber from line$ (i.e. parses line$ from
rem left to right and stops at the first non numeric char.)
rem the line MUST start with a number
rem
rem it returns the line_number%, or 0 if error
rem
local lp%,a$,l%
  a$="":l%=0
  for lp%=1 to 5
    if line$(lp%) instr "0123456789"
      a$=a$&line$(lp%)
    else
      exit lp%
    endif
  end for lp%
  if a$<>"":l%=a$
  return l%
end def get_lineno%
:
def fn get_file%(lineno%,counter%)
rem this gets the file name for an (error) line number (lineno%) and,
rem it also gets the line corresponding to the lineno%
rem it also gets the offset (in number of lines) from the start of the
rem file to the offending line
rem
rem this thus fills in the global arrays modulefile$, linenumber$ and
rem subwinarray$. counter% is the index into the arrays, i.e.the element
rem to be filled in
rem
rem it uses the global variables modulefile$, subwinarray$, l_to_p$, line_increase%
rem
rem this returns 1 if all ok, else 0
rem v. 1.01
local chan%,b$,lp%,procstart%,procend%,c$,file$,found%
  found%=0
  chan%=fop_in(l_to_p$)
  if chan%<0
     chan%=fop_in(default_output_dir$&l_to_p$)
     if chan%<0:return 0	: rem oops
  endif
  rep lp%
    if eof(#chan%):exit lp%	: rem loop until end of file
    input#chan%,b$		: rem first line is always empty
    input#chan%,b$		: rem "Lines x TO y"
    if len(b$)<20 : exit lp%	: rem ooops, serious prob in the l2p file!
    procstart%=b$(7 to 11)	: rem start line
    procend%=b$(16 to 20)	: rem end line
    if procstart%<= lineno% and procend%>=lineno%:found%=1:exit lp%
    if lineno%<procstart%:exit lp%	: rem too small a line
    input#chan%,b$:input#chan%,b$ : rem skip over the next two
  end rep lp%
  if not found%:close#chan%:return 0
  input#chan%,b$		: rem name of procedure
  input#chan%,b$		: rem name of file...
  b$=b$(9 to)			: rem ...now
  close#chan%
  procend%="(" instr b$ 	: rem now get start line for this file
  c$=b$(procend%+1 to len(b$)-1): rem get line number
  b$=b$(1 to procend%-2)	: rem strip rest of line (and space)
  if not ftest(default_input_dir$&b$):b$=default_input_dir$&b$
rem old  if ftest(b$):b$=default_input_dir$&b$
  modulefile$(counter%)=b$
  procend%=c$			: rem start line of this file
  procend%=(lineno%-procend%) div line_increase% : rem how many line in this..
				: rem ... file until we reach the start of this procedure?
  chan%=fop_in(b$)
  if chan%<0:return 0
  for lp%=0 to procend%
    input#chan%,b$
  end for lp%
  close#chan%
  subwinarray$(counter%)=make_length$(b$,39)&" : "
  linenumber$(counter%)=procend%+1
  return 1
end def get_file%
:
def fn make_length$(string$,length%)
rem this makes sure that a string is of length% length, by either cutting
rem off the right edge if it is too long, or by padding it with spaces on
rem the right if it is too short
rem
local a$,leng%
  a$=string$
  leng%=len(a$)
  if leng%=length%:return a$
  if leng%<length%
     return a$&fill$(' ',length%-leng%) : rem padd with spaces on right
  else
     return a$(1 to length%)
  endif
end def make_length$
:
