def fn read_file_error% (my_file$)
rem this opens source file, reads it line by line, numbers it
rem and sends it to the output file
rem possibly adjusts the other output files
rem
rem returns 1 if ok, 0 if error (= line number too big)
rem global vars used are:
rem line_number%, line_increase%, #errfile%
rem default_input_dir$,#output_file%
rem procedure_name$ and in_procedure% are locals from parse_input_not_ok%
rem
rem this_file$ is for correct error reporting of the offending file name
rem  v.1.05
local lp%,input_channel%,one_line$,temp%,file_start_line%
local is_new_file%,this_file$,a$,lline%,lp2%
  this_file$=my_file$
  input_channel%=fop_in(default_input_dir$&my_file$): rem try to open this file
  if input_channel%<0
      this_file$=my_file$
      temp%=fop_in(this_file$)	: rem if failed , use default dir
      if temp%>0
	 input_channel%=temp%	: rem file opened ok
      else
	 print#errfile%,my_file$	: rem here, report name as it appears in the file
	 print#errfile%;error_message$(22);
	 report#errfile%,input_channel% : rem oops, coudn't open file
	 print#errfile%,in_file$	: rem file containing this wrong line
	 print#errfile%,line_in_file%
	 return 0			: rem if input error return NO ERROR!
      endif
  endif
  file_start_line%=line_number% : rem line no at which this file starts
  is_new_file%=1			: rem show that we are starting on new file
  old_line$=""
  lline%=0
  rep lp%
    if eof(#input_channel%): exit lp%
    input#input_channel%,one_line$	: rem get one line
    one_line$=exp_tabs$(one_line$,tab_spaces%,1): rem if tab compression, expand it
    if one_line$='':next lp%		: rem ignore empty lines
    if concat_lines%
       temp%=len(one_line$)		: rem see whether we contatenate lines
       if one_line$(temp%)=concat$
	 rep lp2%
	 input#input_channel%,a$	: rem get new input line
	 one_line$=one_line$(1 to temp%-1)&" "&exp_tabs$(a$,tab_spaces%)
	 lline%=lline%+line_increase% : rem show that line increased
	 temp%=len(one_line$)
	 if one_line$(temp%)<>concat$:exit lp2%
	 end rep lp2%
       endif
    endif
    parse_for_definitions one_line$	: rem check for proc/fn definitions
    print#output_file%,line_number%;" ";
    if (line_number% + line_increase% + lline%) > 32767
       close#input_channel%		: rem line number gets too big
       return 1 		: rem show it
    end if
    print#output_file%,one_line$
    line_number%=line_number%+line_increase%+lline%
    lline%=0
    is_new_file%=0
  end rep lp%
  close#input_channel%		: rem we are now at end of this file
  if in_procedure% or header_is_set%
    line_number%=line_number%-line_increase%
    end_of_procedure		: rem show end of this file now
    line_number%=line_number%+line_increase%
  endif
  header_is_set%=0:in_procedure%=0
  return	0			: rem show no error
end def read_file
:
def proc parse_for_definitions (line$)
rem this checks whether a line contains a DEFine FuNction, DEFine PROCedure
rem END DEFine or RESTORE, These MUST be the first words on the line
rem if yes, it sends the relevant information to the output files
rem global vars used: #lines_to_procs%, #procs_to_lines%
rem procedure_name$,line_number%
rem file_start_line% and is_new_file% are local vars from read_file
rem IS_PROC returns :
rem	empty line if no special keyword
rem	"-1" if error
rem	"-2" if end def
rem	"-3" if restore
rem	the proc or function NAME if def fn or def proc
rem v 1.01
local lp%
  proc_name$=is_proc(line$)		: rem see whether it is a definition
  if proc_name$="" or proc_name$="-3"
     if proc_name$="-3":line$="restore "&line_number%
     if is_new_file%
				: rem did we just start a new file?
       if not in_procedure%
	 proc_name$="(no proc or function)" : rem if no defn and first line in...
	 new_procedure
	 header_is_set%=1
	 return
       else
	 proc_name$=procedure_name$
	 new_procedure
	 return
       endif
     else
       if not header_is_set% and not in_procedure%
	 proc_name$="(no proc or function)" : rem if no defn and first line in...
	 type$="Function"
	 new_procedure
	 header_is_set%=1
       endif
       return
     endif
     return
  endif
  if proc_name$="-1"
     print#errfile%,line$
     print#errfile%;error_message$(23)
     print#errfile%;this_file$	: rem here, report name as it was opened
     print#errfile%;(line_number%-file_start_line%+line_increase%) div line_increase%
     return			: rem if error: show it in error file
  endif
  type$="Function ":if 'proc' instr line$:type$="Procedure "
  if proc_name$<>"-2"
     if (not in_procedure%) and header_is_set%
       line_number%=line_number%-line_increase%
       end_of_procedure
       line_number%=line_number%+line_increase%
     else
       if in_procedure%
	 print#errfile%,line$
	 print#errfile%;error_message$(32)
	 print#errfile%;this_file$  : rem here, report name as it was opened
	 print#errfile%;(line_number%-file_start_line%+line_increase%) div line_increase%
	 return 		    : rem if error: show it in error file
       endif
     endif
     new_procedure
     in_procedure%=1		: rem show that now we are in a proc/fn
  else
     end_of_procedure
     in_procedure%=0
     procedure_name$="(no proc or function)"
  endif
  is_new_file%=0
  header_is_set%=0
end def parse_for_definitions
:
def fn justified$(number%)
rem this right justifies a number into 5 spaces
local strlen%,a$
  a$=number%
  strlen%=len(a$)
  if strlen%<5:a$=fill$(' ',5-strlen%)&a$
  return a$
end def justified$
:
def proc new_procedure
rem this is called whenever a def fn/proc is encountered
local temp%,arr$(1,1)
  procedure_name$=proc_name$
  print #lines_to_procs%\\"Lines "; justified$(line_number%); " TO ";
  print#procs_to_lines%\\type$;proc_name$
  print#procs_to_lines%;"   Lines ";justified$(line_number%);' TO ';
  oldtype$=type$
  if "(" instr proc_name$:return
  proc_nbrs%=proc_nbrs%+1
  myprocs$(proc_nbrs%)=proc_name$
  if proc_nbrs%=dimn(myprocs$,1)
    temp%=dimn(myprocs$,1)+50
    dim arr$(temp%,50)
    arrcopy myprocs$,arr$
    dim myprocs$(temp%,50)
    arrcopy arr$,myprocs$
  endif
end def new_procedure
:
def proc end_of_procedure
rem called at end of procedure & beginning of proc if free line n earlier)
  print#lines_to_procs%;justified$(line_number%)
  print#lines_to_procs%;"    ";oldtype$;procedure_name$
  print#lines_to_procs%;"    in: ";my_file$;" (";file_start_line%;")"
  print#procs_to_lines%;justified$(line_number%)
  print#procs_to_lines%;"    in: ";my_file$
  procedure_name$=""
end def end_of_procedure
:
